Package org.apache.torque.sql

## Class SqlBuilderTest

- java.lang.Object
- - org.apache.torque.BaseTestCase
  - - org.apache.torque.sql.SqlBuilderTest

-     public class SqlBuilderTest
      extends BaseTestCase

  Tests for SqlExpression
  Version:
    $Id: SqlBuilderTest.java 1850726 2019-01-08 10:56:07Z gk $
  Author:
    Martin Poeschl, Scott Eade

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `SqlBuilderTest.EnumWithoutValueMethod` |
    `static class` | `SqlBuilderTest.EnumWithValueMethod` |

  - ### Field Summary

    - ### Fields inherited from class org.apache.torque.BaseTestCase

      `CONFIG_FILE, database, databaseMap, databaseMysql, databaseOracle, databasePostgresql, integerColumnMap, stringColumnMap, stringColumnMap2, stringColumnMap3, tableMap`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SqlBuilderTest()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `testAlias()` |
    `void` | `testAliasWithDefaultSchema()` |
    `void` | `testAliasWithIgnoreCaseIntegerColumnType()` |
    `void` | `testAliasWithIgnoreCaseIntegerColumnTypeAndDefaultSchema()` |
    `void` | `testAliasWithIgnoreCaseStringColumnType()` |
    `void` | `testAliasWithIgnoreCaseStringColumnTypeAndDefaultSchema()` |
    `void` | `testAliasWithIgnoreCaseUnknownColumnType()` |
    `void` | `testAliasWithSubquery()` |
    `void` | `testAliasWithSubqueryAndReplacements()` |
    `void` | `testAndCriterions()` | Test where condition with several ANDs compairing against Strings.
    `void` | `testAndString()` | Test where condition with several ANDs compairing against Strings.
    `void` | `testAndVerbatimSqlReplacementNull()` | Test the andVerbatimSql method with null replacements.
    `void` | `testAndVerbatimSqlWithFromColumns()` | Test the andVerbatimSql method with from Columns.
    `void` | `testAndVerbatimSqlWithReplacements()` | Test the andVerbatimSql method with replacements.
    `void` | `testAsColumn()` |
    `void` | `testAsColumnWithIgnoreCaseIntegerColumn()` |
    `void` | `testAsColumnWithIgnoreCaseIntegerColumnAndDefaultSchema()` |
    `void` | `testAsColumnWithIgnoreCaseStringColumn()` |
    `void` | `testAsColumnWithIgnoreCaseStringColumnAndDefaultSchema()` |
    `void` | `testAsColumnWithIgnoreCaseUnknownColumn()` |
    `void` | `testCriterionCustomSql()` |
    `void` | `testCurrentDate()` |
    `void` | `testCurrentTime()` |
    `void` | `testCurrentTimestamp()` |
    `void` | `testDistinct()` |
    `void` | `testEnumValues()` |
    `void` | `testEnumValuesNoGetValueMethod()` | Tests that an enum which does not have a getValue() method cannot be added as select value.
    `void` | `testExcept()` |
    `void` | `testExceptAll()` |
    `void` | `testFromElementsSetExplicitly()` |
    `void` | `testFromElementsSetExplicitlyAsString()` |
    `void` | `testGroupBy()` |
    `void` | `testHaving()` |
    `void` | `testIgnoreCaseIntegerColumnType()` |
    `void` | `testIgnoreCaseStringColumnType()` |
    `void` | `testignoreCaseUnknownColumnType()` | Test that unknown columns are treated case-insensitive if ignoreCase is set.
    `void` | `testIlike()` |
    `void` | `testIlikeNoWildcard()` |
    `void` | `testInArray()` |
    `void` | `testInArrayIgnoreCase()` |
    `void` | `testInLargeArray()` |
    `void` | `testInList()` |
    `void` | `testInListIgnoreCase()` |
    `void` | `testInnerJoinExcplicitWithExistingRightAndLeftTable()` |
    `void` | `testInnerJoinExplicit()` |
    `void` | `testInnerJoinExplicitWithComplicatedCondition()` |
    `void` | `testInnerJoinExplicitWithSubselect()` | Tests that a subselect can be added to the from clause.
    `void` | `testInnerJoinImplicit()` |
    `void` | `testInnerJoinImplicitWithAlias()` |
    `void` | `testInnerJoinImplicitWithAliasAndAsColumn()` |
    `void` | `testInnerJoinImplicitWithAliasAndDefaultSchema()` |
    `void` | `testInnerJoinImplicitWithAliasAndSchema()` |
    `void` | `testInnerJoinImplicitWithComparison()` |
    `void` | `testInnerJoinImplicitWithComplicatedCondition()` |
    `void` | `testInnerJoinImplicitWithDefaultSchema()` |
    `void` | `testInnerJoinImplicitWithSubqueryAndReplacements()` |
    `void` | `testInnerJoinWithExcplicitExistingRightTable()` |
    `void` | `testInnerJoinWithExcplicitExistingRightTableAndOperator()` |
    `void` | `testInnerJoinWithJoinCriteriaAndDefaultSchema()` |
    `void` | `testInString()` |
    `void` | `testIntersect()` |
    `void` | `testIntersectAll()` |
    `void` | `testIsNotNull()` |
    `void` | `testIsNull()` |
    `void` | `testLeftJoin()` |
    `void` | `testLeftJoinWithExistingRightTable()` |
    `void` | `testLike()` |
    `void` | `testLikeIgnoreCase()` |
    `void` | `testLikeIgnoreCaseNoWildcard()` |
    `void` | `testLikeInteger()` |
    `void` | `testLikeWithEscape()` | Test whether LIKE clauses with Escapes are built correctly.
    `void` | `testLikeWithEscapeOracle()` | Test whether LIKE clauses with Escapes are built correctly in Oracle.
    `void` | `testLimitMysql()` |
    `void` | `testLimitOffsetMysql()` |
    `void` | `testLimitOffsetOracle()` |
    `void` | `testLimitOffsetPostgresql()` |
    `void` | `testLimitOracle()` |
    `void` | `testLimitPostgresql()` |
    `void` | `testLvalueCriteria()` |
    `void` | `testLvalueIsObject()` |
    `void` | `testLvalueNull()` |
    `void` | `testLvalueString()` |
    `void` | `testNotIlike()` |
    `void` | `testNotIlikeNoWildcard()` |
    `void` | `testNotInList()` |
    `void` | `testNotLike()` |
    `void` | `testNotLikeIgnoreCase()` |
    `void` | `testNotLikeIgnoreCaseNoWildcard()` |
    `void` | `testNullValue()` |
    `void` | `testNullValueAltNotEqual()` |
    `void` | `testNullValueNotEqual()` |
    `void` | `testObjectKey()` |
    `void` | `testOffsetMysql()` |
    `void` | `testOffsetOracle()` |
    `void` | `testOffsetPostgresql()` |
    `void` | `testOrCriterions()` | Test where condition with several ORs compairing against Strings.
    `void` | `testOrderByAsc()` |
    `void` | `testOrderByAscendingIgnoreCaseInteger()` |
    `void` | `testOrderByAscendingIgnoreCaseIntegerInCriteria()` |
    `void` | `testOrderByAscendingIgnoreCaseString()` |
    `void` | `testOrderByAscendingIgnoreCaseStringInCriteria()` |
    `void` | `testOrderByDesc()` |
    `void` | `testOrderByDescendingIgnoreCaseInteger()` |
    `void` | `testOrderByDescendingIgnoreCaseIntegerInCriteria()` |
    `void` | `testOrderByDescendingIgnoreCaseString()` |
    `void` | `testOrderByDescendingIgnoreCaseStringInCriteria()` |
    `void` | `testOrderByMultiple()` |
    `void` | `testOrderByNullColumn()` |
    `void` | `testOrderByWithAsColumn()` |
    `void` | `testOrderByWithAsColumnAndAliasIgnoreCase()` |
    `void` | `testOrderByWithAsColumnIgnoreCase()` |
    `void` | `testOrderByWithDefaultSchema()` |
    `void` | `testOrderByWithFunction()` |
    `void` | `testOrString()` | Test where condition with several ORs compairing against Strings.
    `void` | `testOrVerbatimSqlReplacementNull()` | Test the orVerbatimSql method with null replacements.
    `void` | `testOrVerbatimSqlWithFromColumns()` | Test the orVerbatimSql method with from Columns.
    `void` | `testOrVerbatimSqlWithReplacements()` | Test the orVerbatimSql method with replacements.
    `void` | `testRightJoin()` |
    `void` | `testRightJoinWithExistingRightTable()` |
    `void` | `testSelectColumnWithoutTable()` |
    `void` | `testSelectForUpdate()` |
    `void` | `testSetOperationBraces()` |
    `void` | `testSubselect()` |
    `void` | `testSubselectReferenceOuterTable()` |
    `void` | `testUnion()` |
    `void` | `testUnionAll()` |
    `void` | `testUnionOrderByLimitOffset()` |
    `void` | `testWhereVerbatimSqlReplacementNull()` | Test the whereVerbatimSql method with null replacements.
    `void` | `testWhereVerbatimSqlWithFromColumns()` | Test the whereVerbatimSql method with from Columns.
    `void` | `testWhereVerbatimSqlWithReplacements()` | Test the whereVerbatimSql method with replacements.

    - ### Methods inherited from class org.apache.torque.BaseTestCase

      `setUp`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SqlBuilderTest

          public SqlBuilderTest()

  - ### Method Detail

    - #### testAndString

          public void testAndString()
                             throws Exception

      Test where condition with several ANDs compairing against Strings.
      Throws:
        `Exception`

    - #### testOrString

          public void testOrString()
                            throws Exception

      Test where condition with several ORs compairing against Strings.
      Throws:
        `Exception`

    - #### testAndCriterions

          public void testAndCriterions()
                                 throws Exception

      Test where condition with several ANDs compairing against Strings.
      Throws:
        `Exception`

    - #### testOrCriterions

          public void testOrCriterions()
                                throws Exception

      Test where condition with several ORs compairing against Strings.
      Throws:
        `Exception`

    - #### testAndVerbatimSqlReplacementNull

          public void testAndVerbatimSqlReplacementNull()
                                                 throws Exception

      Test the andVerbatimSql method with null replacements.
      Throws:
        `Exception`

    - #### testAndVerbatimSqlWithReplacements

          public void testAndVerbatimSqlWithReplacements()
                                                  throws Exception

      Test the andVerbatimSql method with replacements.
      Throws:
        `Exception`

    - #### testAndVerbatimSqlWithFromColumns

          public void testAndVerbatimSqlWithFromColumns()
                                                 throws Exception

      Test the andVerbatimSql method with from Columns.
      Throws:
        `Exception`

    - #### testOrVerbatimSqlReplacementNull

          public void testOrVerbatimSqlReplacementNull()
                                                throws Exception

      Test the orVerbatimSql method with null replacements.
      Throws:
        `Exception`

    - #### testOrVerbatimSqlWithReplacements

          public void testOrVerbatimSqlWithReplacements()
                                                 throws Exception

      Test the orVerbatimSql method with replacements.
      Throws:
        `Exception`

    - #### testOrVerbatimSqlWithFromColumns

          public void testOrVerbatimSqlWithFromColumns()
                                                throws Exception

      Test the orVerbatimSql method with from Columns.
      Throws:
        `Exception`

    - #### testWhereVerbatimSqlReplacementNull

          public void testWhereVerbatimSqlReplacementNull()
                                                   throws Exception

      Test the whereVerbatimSql method with null replacements.
      Throws:
        `Exception`

    - #### testWhereVerbatimSqlWithReplacements

          public void testWhereVerbatimSqlWithReplacements()
                                                    throws Exception

      Test the whereVerbatimSql method with replacements.
      Throws:
        `Exception`

    - #### testWhereVerbatimSqlWithFromColumns

          public void testWhereVerbatimSqlWithFromColumns()
                                                   throws Exception

      Test the whereVerbatimSql method with from Columns.
      Throws:
        `Exception`

    - #### testignoreCaseUnknownColumnType

          public void testignoreCaseUnknownColumnType()
                                               throws Exception

      Test that unknown columns are treated case-insensitive if ignoreCase is set.
      Throws:
        `Exception`

    - #### testIgnoreCaseStringColumnType

          public void testIgnoreCaseStringColumnType()
                                              throws Exception

      Throws:
        `Exception`

    - #### testIgnoreCaseIntegerColumnType

          public void testIgnoreCaseIntegerColumnType()
                                               throws Exception

      Throws:
        `Exception`

    - #### testOrderByDesc

          public void testOrderByDesc()
                               throws TorqueException

      Throws:
        `TorqueException`

    - #### testOrderByAsc

          public void testOrderByAsc()
                              throws Exception

      Throws:
        `Exception`

    - #### testOrderByNullColumn

          public void testOrderByNullColumn()
                                     throws Exception

      Throws:
        `Exception`

    - #### testOrderByMultiple

          public void testOrderByMultiple()
                                   throws Exception

      Throws:
        `Exception`

    - #### testOrderByWithDefaultSchema

          public void testOrderByWithDefaultSchema()
                                            throws Exception

      Throws:
        `Exception`

    - #### testOrderByWithFunction

          public void testOrderByWithFunction()
                                       throws Exception

      Throws:
        `Exception`

    - #### testOrderByWithAsColumn

          public void testOrderByWithAsColumn()
                                       throws Exception

      Throws:
        `Exception`

    - #### testOrderByWithAsColumnIgnoreCase

          public void testOrderByWithAsColumnIgnoreCase()
                                                 throws Exception

      Throws:
        `Exception`

    - #### testOrderByWithAsColumnAndAliasIgnoreCase

          public void testOrderByWithAsColumnAndAliasIgnoreCase()
                                                         throws Exception

      Throws:
        `Exception`

    - #### testOrderByAscendingIgnoreCaseString

          public void testOrderByAscendingIgnoreCaseString()
                                                    throws Exception

      Throws:
        `Exception`

    - #### testOrderByAscendingIgnoreCaseInteger

          public void testOrderByAscendingIgnoreCaseInteger()
                                                     throws Exception

      Throws:
        `Exception`

    - #### testOrderByAscendingIgnoreCaseStringInCriteria

          public void testOrderByAscendingIgnoreCaseStringInCriteria()
                                                              throws Exception

      Throws:
        `Exception`

    - #### testOrderByAscendingIgnoreCaseIntegerInCriteria

          public void testOrderByAscendingIgnoreCaseIntegerInCriteria()
                                                               throws Exception

      Throws:
        `Exception`

    - #### testOrderByDescendingIgnoreCaseString

          public void testOrderByDescendingIgnoreCaseString()
                                                     throws Exception

      Throws:
        `Exception`

    - #### testOrderByDescendingIgnoreCaseInteger

          public void testOrderByDescendingIgnoreCaseInteger()
                                                      throws Exception

      Throws:
        `Exception`

    - #### testOrderByDescendingIgnoreCaseStringInCriteria

          public void testOrderByDescendingIgnoreCaseStringInCriteria()
                                                               throws Exception

      Throws:
        `Exception`

    - #### testOrderByDescendingIgnoreCaseIntegerInCriteria

          public void testOrderByDescendingIgnoreCaseIntegerInCriteria()
                                                                throws Exception

      Throws:
        `Exception`

    - #### testAlias

          public void testAlias()
                         throws Exception

      Throws:
        `Exception`

    - #### testAliasWithDefaultSchema

          public void testAliasWithDefaultSchema()
                                          throws Exception

      Throws:
        `Exception`

    - #### testAliasWithIgnoreCaseUnknownColumnType

          public void testAliasWithIgnoreCaseUnknownColumnType()
                                                        throws Exception

      Throws:
        `Exception`

    - #### testAliasWithSubquery

          public void testAliasWithSubquery()
                                     throws Exception

      Throws:
        `Exception`

    - #### testAliasWithSubqueryAndReplacements

          public void testAliasWithSubqueryAndReplacements()
                                                    throws Exception

      Throws:
        `Exception`

    - #### testAliasWithIgnoreCaseStringColumnType

          public void testAliasWithIgnoreCaseStringColumnType()
                                                       throws Exception

      Throws:
        `Exception`

    - #### testAliasWithIgnoreCaseIntegerColumnType

          public void testAliasWithIgnoreCaseIntegerColumnType()
                                                        throws Exception

      Throws:
        `Exception`

    - #### testAliasWithIgnoreCaseStringColumnTypeAndDefaultSchema

          public void testAliasWithIgnoreCaseStringColumnTypeAndDefaultSchema()
                                                                       throws Exception

      Throws:
        `Exception`

    - #### testAliasWithIgnoreCaseIntegerColumnTypeAndDefaultSchema

          public void testAliasWithIgnoreCaseIntegerColumnTypeAndDefaultSchema()
                                                                        throws Exception

      Throws:
        `Exception`

    - #### testAsColumn

          public void testAsColumn()
                            throws Exception

      Throws:
        `Exception`

    - #### testAsColumnWithIgnoreCaseUnknownColumn

          public void testAsColumnWithIgnoreCaseUnknownColumn()
                                                       throws Exception

      Throws:
        `Exception`

    - #### testAsColumnWithIgnoreCaseStringColumn

          public void testAsColumnWithIgnoreCaseStringColumn()
                                                      throws Exception

      Throws:
        `Exception`

    - #### testAsColumnWithIgnoreCaseIntegerColumn

          public void testAsColumnWithIgnoreCaseIntegerColumn()
                                                       throws Exception

      Throws:
        `Exception`

    - #### testAsColumnWithIgnoreCaseStringColumnAndDefaultSchema

          public void testAsColumnWithIgnoreCaseStringColumnAndDefaultSchema()
                                                                      throws Exception

      Throws:
        `Exception`

    - #### testAsColumnWithIgnoreCaseIntegerColumnAndDefaultSchema

          public void testAsColumnWithIgnoreCaseIntegerColumnAndDefaultSchema()
                                                                       throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinImplicit

          public void testInnerJoinImplicit()
                                     throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinImplicitWithComparison

          public void testInnerJoinImplicitWithComparison()
                                                   throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinExplicit

          public void testInnerJoinExplicit()
                                     throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinWithExcplicitExistingRightTable

          public void testInnerJoinWithExcplicitExistingRightTable()
                                                            throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinWithExcplicitExistingRightTableAndOperator

          public void testInnerJoinWithExcplicitExistingRightTableAndOperator()
                                                                       throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinExcplicitWithExistingRightAndLeftTable

          public void testInnerJoinExcplicitWithExistingRightAndLeftTable()
                                                                   throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinExplicitWithComplicatedCondition

          public void testInnerJoinExplicitWithComplicatedCondition()
                                                             throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinExplicitWithSubselect

          public void testInnerJoinExplicitWithSubselect()
                                                  throws Exception

      Tests that a subselect can be added to the from clause.
      Throws:
        `Exception` - if an error occurs

    - #### testInnerJoinWithJoinCriteriaAndDefaultSchema

          public void testInnerJoinWithJoinCriteriaAndDefaultSchema()
                                                             throws Exception

      Throws:
        `Exception`

    - #### testLeftJoin

          public void testLeftJoin()
                            throws Exception

      Throws:
        `Exception`

    - #### testLeftJoinWithExistingRightTable

          public void testLeftJoinWithExistingRightTable()
                                                  throws Exception

      Throws:
        `Exception`

    - #### testRightJoin

          public void testRightJoin()
                             throws Exception

      Throws:
        `Exception`

    - #### testRightJoinWithExistingRightTable

          public void testRightJoinWithExistingRightTable()
                                                   throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinImplicitWithAlias

          public void testInnerJoinImplicitWithAlias()
                                              throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinImplicitWithAliasAndAsColumn

          public void testInnerJoinImplicitWithAliasAndAsColumn()
                                                         throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinImplicitWithDefaultSchema

          public void testInnerJoinImplicitWithDefaultSchema()
                                                      throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinImplicitWithAliasAndDefaultSchema

          public void testInnerJoinImplicitWithAliasAndDefaultSchema()
                                                              throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinImplicitWithAliasAndSchema

          public void testInnerJoinImplicitWithAliasAndSchema()
                                                       throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinImplicitWithSubqueryAndReplacements

          public void testInnerJoinImplicitWithSubqueryAndReplacements()
                                                                throws Exception

      Throws:
        `Exception`

    - #### testInnerJoinImplicitWithComplicatedCondition

          public void testInnerJoinImplicitWithComplicatedCondition()
                                                             throws Exception

      Throws:
        `Exception`

    - #### testDistinct

          public void testDistinct()
                            throws Exception

      Throws:
        `Exception`

    - #### testGroupBy

          public void testGroupBy()
                           throws Exception

      Throws:
        `Exception`

    - #### testLimitPostgresql

          public void testLimitPostgresql()
                                   throws Exception

      Throws:
        `Exception`

    - #### testOffsetPostgresql

          public void testOffsetPostgresql()
                                    throws Exception

      Throws:
        `Exception`

    - #### testLimitOffsetPostgresql

          public void testLimitOffsetPostgresql()
                                         throws Exception

      Throws:
        `Exception`

    - #### testLimitMysql

          public void testLimitMysql()
                              throws Exception

      Throws:
        `Exception`

    - #### testOffsetMysql

          public void testOffsetMysql()
                               throws Exception

      Throws:
        `Exception`

    - #### testLimitOffsetMysql

          public void testLimitOffsetMysql()
                                    throws Exception

      Throws:
        `Exception`

    - #### testLimitOracle

          public void testLimitOracle()
                               throws Exception

      Throws:
        `Exception`

    - #### testOffsetOracle

          public void testOffsetOracle()
                                throws Exception

      Throws:
        `Exception`

    - #### testLimitOffsetOracle

          public void testLimitOffsetOracle()
                                     throws Exception

      Throws:
        `Exception`

    - #### testSelectForUpdate

          public void testSelectForUpdate()
                                   throws Exception

      Throws:
        `Exception`

    - #### testHaving

          public void testHaving()
                          throws Exception

      Throws:
        `Exception`

    - #### testSelectColumnWithoutTable

          public void testSelectColumnWithoutTable()
                                            throws Exception

      Throws:
        `Exception`

    - #### testCriterionCustomSql

          public void testCriterionCustomSql()
                                      throws Exception

      Throws:
        `Exception`

    - #### testLvalueIsObject

          public void testLvalueIsObject()
                                  throws Exception

      Throws:
        `Exception`

    - #### testCurrentDate

          public void testCurrentDate()
                               throws Exception

      Throws:
        `Exception`

    - #### testCurrentTime

          public void testCurrentTime()
                               throws Exception

      Throws:
        `Exception`

    - #### testCurrentTimestamp

          public void testCurrentTimestamp()
                                    throws Exception

      Throws:
        `Exception`

    - #### testObjectKey

          public void testObjectKey()
                             throws Exception

      Throws:
        `Exception`

    - #### testNullValue

          public void testNullValue()
                             throws Exception

      Throws:
        `Exception`

    - #### testNullValueNotEqual

          public void testNullValueNotEqual()
                                     throws Exception

      Throws:
        `Exception`

    - #### testNullValueAltNotEqual

          public void testNullValueAltNotEqual()
                                        throws Exception

      Throws:
        `Exception`

    - #### testIsNull

          public void testIsNull()
                          throws Exception

      Throws:
        `Exception`

    - #### testIsNotNull

          public void testIsNotNull()
                             throws Exception

      Throws:
        `Exception`

    - #### testSubselect

          public void testSubselect()
                             throws Exception

      Throws:
        `Exception`

    - #### testSubselectReferenceOuterTable

          public void testSubselectReferenceOuterTable()
                                                throws Exception

      Throws:
        `Exception`

    - #### testLike

          public void testLike()
                        throws Exception

      Throws:
        `Exception`

    - #### testLikeWithEscape

          public void testLikeWithEscape()
                                  throws TorqueException

      Test whether LIKE clauses with Escapes are built correctly.
      Throws:
        `TorqueException`

    - #### testLikeWithEscapeOracle

          public void testLikeWithEscapeOracle()
                                        throws TorqueException

      Test whether LIKE clauses with Escapes are built correctly in Oracle. Oracle needs to have an ESCAPE clause
      Throws:
        `TorqueException`

    - #### testLikeIgnoreCase

          public void testLikeIgnoreCase()
                                  throws Exception

      Throws:
        `Exception`

    - #### testLikeIgnoreCaseNoWildcard

          public void testLikeIgnoreCaseNoWildcard()
                                            throws Exception

      Throws:
        `Exception`

    - #### testLikeInteger

          public void testLikeInteger()
                               throws TorqueException

      Throws:
        `TorqueException`

    - #### testNotLike

          public void testNotLike()
                           throws Exception

      Throws:
        `Exception`

    - #### testNotLikeIgnoreCase

          public void testNotLikeIgnoreCase()
                                     throws Exception

      Throws:
        `Exception`

    - #### testNotLikeIgnoreCaseNoWildcard

          public void testNotLikeIgnoreCaseNoWildcard()
                                               throws Exception

      Throws:
        `Exception`

    - #### testIlike

          public void testIlike()
                         throws Exception

      Throws:
        `Exception`

    - #### testIlikeNoWildcard

          public void testIlikeNoWildcard()
                                   throws Exception

      Throws:
        `Exception`

    - #### testNotIlike

          public void testNotIlike()
                            throws Exception

      Throws:
        `Exception`

    - #### testNotIlikeNoWildcard

          public void testNotIlikeNoWildcard()
                                      throws Exception

      Throws:
        `Exception`

    - #### testLvalueString

          public void testLvalueString()
                                throws Exception

      Throws:
        `Exception`

    - #### testLvalueNull

          public void testLvalueNull()
                              throws Exception

      Throws:
        `Exception`

    - #### testLvalueCriteria

          public void testLvalueCriteria()
                                  throws Exception

      Throws:
        `Exception`

    - #### testInArray

          public void testInArray()
                           throws Exception

      Throws:
        `Exception`

    - #### testInArrayIgnoreCase

          public void testInArrayIgnoreCase()
                                     throws Exception

      Throws:
        `Exception`

    - #### testInList

          public void testInList()
                          throws Exception

      Throws:
        `Exception`

    - #### testInListIgnoreCase

          public void testInListIgnoreCase()
                                    throws Exception

      Throws:
        `Exception`

    - #### testNotInList

          public void testNotInList()
                             throws Exception

      Throws:
        `Exception`

    - #### testInLargeArray

          public void testInLargeArray()
                                throws TorqueException

      Throws:
        `TorqueException`

    - #### testInString

          public void testInString()
                            throws Exception

      Throws:
        `Exception`

    - #### testFromElementsSetExplicitly

          public void testFromElementsSetExplicitly()
                                             throws Exception

      Throws:
        `Exception`

    - #### testFromElementsSetExplicitlyAsString

          public void testFromElementsSetExplicitlyAsString()
                                                     throws Exception

      Throws:
        `Exception`

    - #### testUnion

          public void testUnion()
                         throws Exception

      Throws:
        `Exception`

    - #### testUnionAll

          public void testUnionAll()
                            throws Exception

      Throws:
        `Exception`

    - #### testExcept

          public void testExcept()
                          throws Exception

      Throws:
        `Exception`

    - #### testExceptAll

          public void testExceptAll()
                             throws Exception

      Throws:
        `Exception`

    - #### testIntersect

          public void testIntersect()
                             throws Exception

      Throws:
        `Exception`

    - #### testIntersectAll

          public void testIntersectAll()
                                throws Exception

      Throws:
        `Exception`

    - #### testUnionOrderByLimitOffset

          public void testUnionOrderByLimitOffset()
                                           throws Exception

      Throws:
        `Exception`

    - #### testSetOperationBraces

          public void testSetOperationBraces()
                                      throws Exception

      Throws:
        `Exception`

    - #### testEnumValues

          public void testEnumValues()
                              throws Exception

      Throws:
        `Exception`

    - #### testEnumValuesNoGetValueMethod

          public void testEnumValuesNoGetValueMethod()
                                              throws Exception

      Tests that an enum which does not have a getValue() method cannot be added as select value.
      Throws:
        `Exception`